--INSEMINAES e TE e COB
select
  an.numero as "Nmero da vaca"
  , an.cdanimal
  , ia.data as "Data"
  , cast((case when (ia.cdtiporeproducao=1) then 'IA'
		when (ia.cdtiporeproducao=2) then 'COB'
		when (ia.cdtiporeproducao=3) then 'TE' else ''
		end) as varchar(30)) as "Tipo de evento"
  , coalesce(tou.numero, paiemb.numero) as "[IA] Touro IA, COB ou pai EMB"
  , cast(doadora.numero as varchar(20)) as "[TE] Numero doadora"
  , cast(doadora.cdanimal as varchar(20)) as "[TE] Cdanimal doadora"
  , cast((case when (diag.diagnostico = 'P') then 'positivo'
            when (diag.cdreproducao is not null) then 'negativo'
            else '' end) as varchar(10)) as "[IA] Diagnstico desta IA"
  , cast('' as varchar(10)) as "[DG] Diagstico de gestao"
  , cast('' as varchar(10)) as "[Aborto] Aborto"
  , cast('' as varchar(10)) as "[Aborto] Iniciou nova lactao"
  , cast('' as varchar(10)) as "[Parto] Ordem de lactao"
  , cast('' as varchar(10)) as "[Parto] Sexo da cria"
  , cast('' as varchar(10)) as "[Parto] Status da cria"
  , cast('' as varchar(10)) as "[Parto] Nmero da cria"
  , cast('' as varchar(10)) as "[Secagem] Secagem"
  , cast('' as varchar(10)) as "[Sada] Sada"
  , cast('' as varchar(10)) as "[Sada] Motivo"
from
  animal an
  join reproducao ia on ia.cdanimal = an.cdanimal
  left join animal tou on tou.cdanimal = ia.cdreprodutor
  left join reproducao diag on diag.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and
            re.data > ia.data and
            ((re.cdtiporeproducao in (1,2,3)) or (re.diagnostico is not null) or (re.cio in (1,2)))
            order by re.data asc)
  left join animal emb on emb.cdanimal=ia.cdembriao
  left join animal doadora on doadora.cdanimal=emb.cdmae
  left join animal paiemb on paiemb.cdanimal=emb.cdpai
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and ia.cdtiporeproducao in (1,2,3)

union all

--DIAGNSTICOS DE GESTAO
select
  an.numero as "Nmero da vaca"
  , an.cdanimal
  , dg.data as "Data"
  , cast('Diagnstico de gestao' as varchar(30)) as "Tipo de evento"
  , cast('' as varchar(20)) as "[IA] Touro usado na IA"
  , cast('' as varchar(20)) as "[TE] Doadora"
  , cast('' as varchar(20)) as "[TE] Cdanimal doadora"
  , cast('' as varchar(10)) as "[IA] Diagnstico desta IA"
  , cast((case when (dg.diagnostico = 'P')
                then 'Positivo'
                else 'Negativo' end) as varchar(10)) as "[DG] Diagstico de gestao"
  , cast('' as varchar(10)) as "[Aborto] Aborto"
  , cast('' as varchar(10)) as "[Aborto] Iniciou nova lactao"
  , cast('' as varchar(10)) as "[Parto] Ordem de lactao"
  , cast('' as varchar(10)) as "[Parto] Sexo da cria"
  , cast('' as varchar(10)) as "[Parto] Status da cria"
  , cast('' as varchar(10)) as "[Parto] Nmero da cria"
  , cast('' as varchar(10)) as "[Secagem] Secagem"
  , cast('' as varchar(10)) as "[Sada] Sada"
  , cast('' as varchar(10)) as "[Sada] Motivo"
from
  animal an
  join reproducao dg on dg.cdanimal = an.cdanimal
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and dg.diagnostico is not null

union all

--ABORTOS   
select
  an.numero as "Nmero da vaca"
  , an.cdanimal
  , ab.data as "Data"
  , cast('Aborto' as varchar(30)) as "Tipo de evento"
  , cast('' as varchar(20)) as "[IA] Touro usado na IA"
  , cast('' as varchar(20)) as "[TE] Doadora"
  , cast('' as varchar(20)) as "[TE] Cdanimal doadora"
  , cast('' as varchar(10)) as "[IA] Diagnstico desta IA"
  , cast('' as varchar(10)) as "[DG] Diagstico de gestao"
  , cast('Sim' as varchar(10)) as "[Aborto] Aborto"
  , cast((case when (lac.cdlactacao is not null) then 'Sim' else 'No' end) as varchar(10)) as "[Aborto] Iniciou nova lactao"
  , cast('' as varchar(10)) as "[Parto] Ordem de lactao"
  , cast('' as varchar(10)) as "[Parto] Sexo da cria"
  , cast('' as varchar(10)) as "[Parto] Status da cria"
  , cast('' as varchar(10)) as "[Parto] Nmero da cria"
  , cast('' as varchar(10)) as "[Secagem] Secagem"
  , cast('' as varchar(10)) as "[Sada] Sada"
  , cast('' as varchar(10)) as "[Sada] Motivo"
from
  animal an
  join reproducao ab on ab.cdanimal = an.cdanimal
  left join lactacao lac on lac.cdanimal = ab.cdanimal and lac.dtinicio = ab.data
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and ab.cdtipoparto = 3

union all

--PARTOS
select
  an.numero as "Nmero da vaca"
  , an.cdanimal
  , par.data as "Data"
  , cast('Parto' as varchar(30)) as "Tipo de evento"
  , cast('' as varchar(20)) as "[IA] Touro usado na IA"
  , cast('' as varchar(20)) as "[TE] Doadora"
  , cast('' as varchar(20)) as "[TE] Cdanimal doadora"
  , cast('' as varchar(10)) as "[IA] Diagnstico desta IA"
  , cast('' as varchar(10)) as "[DG] Diagstico de gestao"
  , cast('' as varchar(10)) as "[Aborto] Aborto"
  , cast('' as varchar(10)) as "[Aborto] Iniciou nova lactao"
  , cast(coalesce((select count(*) from lactacao lac
                            where lac.cdanimal = par.cdanimal
                            and lac.dtinicio <= par.data), 0) as varchar(10)) as "[Parto] Ordem de lactao"
  , cast(coalesce(cria.sexo, par.sexocria1) as varchar(10)) as "[Parto] Sexo da cria"
  , cast((case when (par.cdtipoparto = 4)
                then ('morto')
                else 'vivo' end) as varchar(10)) as "[Parto] Status da cria"
  , cast(cria.numero as varchar(10)) as "[Parto] Nmero da cria"
  , cast('' as varchar(10)) as "[Secagem] Secagem"
  , cast('' as varchar(10)) as "[Sada] Sada"
  , cast('' as varchar(10)) as "[Sada] Motivo"
from
  animal an
  join reproducao par on par.cdanimal = an.cdanimal
  left join animal cria on cria.cdanimal =
    (select first 1 re.cdanimal from animal re where re.cdreproducao = par.cdreproducao order by re.cdanimal asc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and par.cdtiporeproducao = 7 and par.cdtipoparto <> 3

union all

--SECAGENS
select
  an.numero as "Nmero da vaca"
  , an.cdanimal
  , sec.dtfim as "Data"
  , cast('Secagem' as varchar(30)) as "Tipo de evento"
  , cast('' as varchar(20)) as "[IA] Touro usado na IA"
  , cast('' as varchar(20)) as "[TE] Doadora"
  , cast('' as varchar(20)) as "[TE] Cdanimal doadora"
  , cast('' as varchar(10)) as "[IA] Diagnstico desta IA"
  , cast('' as varchar(10)) as "[DG] Diagstico de gestao"
  , cast('' as varchar(10)) as "[Aborto] Aborto"
  , cast('' as varchar(10)) as "[Aborto] Iniciou nova lactao"
  , cast('' as varchar(10)) as "[Parto] Ordem de lactao"
  , cast('' as varchar(10)) as "[Parto] Sexo da cria"
  , cast('' as varchar(10)) as "[Parto] Status da cria"
  , cast('' as varchar(10)) as "[Parto] Nmero da cria"
  , cast('Sim' as varchar(10)) as "[Secagem] Secagem"
  , cast('' as varchar(10)) as "[Sada] Sada"
  , cast('' as varchar(10)) as "[Sada] Motivo"
from
  animal an
  join lactacao sec on sec.cdanimal = an.cdanimal
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and sec.dtfim is not null

union all

--SADAS
select
  an.numero as "Nmero da vaca"
  , an.cdanimal
  , an.dtbaixa as "Data"
  , cast('Sada' as varchar(30)) as "Tipo de evento"
  , cast('' as varchar(20)) as "[IA] Touro usado na IA"
  , cast('' as varchar(20)) as "[TE] Doadora"
  , cast('' as varchar(20)) as "[TE] Cdanimal doadora"
  , cast('' as varchar(10)) as "[IA] Diagnstico desta IA"
  , cast('' as varchar(10)) as "[DG] Diagstico de gestao"
  , cast('' as varchar(10)) as "[Aborto] Aborto"
  , cast('' as varchar(10)) as "[Aborto] Iniciou nova lactao"
  , cast('' as varchar(10)) as "[Parto] Ordem de lactao"
  , cast('' as varchar(10)) as "[Parto] Sexo da cria"
  , cast('' as varchar(10)) as "[Parto] Status da cria"
  , cast('' as varchar(10)) as "[Parto] Nmero da cria"
  , cast('' as varchar(10)) as "[Secagem] Secagem"
  , cast('Sim' as varchar(10)) as "[Sada] Sada"
  , cast((case when ((mb.padrao = 1) or (an.cdtipobaixa = 1)) then 'Venda'
                when (an.cdtipobaixa = 3) then 'Morte'
                else 'Descarte' end) as varchar(10)) as "[Sada] Motivo"
from
  animal an
  left join motivobaixa mb on mb.cdmotivobaixa = an.cdmotivobaixa
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is not null

order by 1, 2
